<template lang="pug">
  div.discord.container
    el-row(justify="center" align="middle" type="flex")
      h1 #[span.highlight Coco]: The Auto-Gallery
    el-row( justify="center" align="middle" type="flex")
      el-row.login.card(justify="center" type="flex")
        el-card
          el-row(justify="center" align="middle" type="flex")
            h2 #[i.bx.bxs-dashboard] Dashboard
          div(v-if="user && !loading")
            el-row(justify="center" type="flex")
              el-row(justify="center" align="middle" type="flex")
                el-avatar(:src="getAvatar()")
                el-tag(type="primary") {{user.username}}\#{{user.discriminator}}
                el-button(type="danger" plain @click="logOut" size="mini") Log Out
            el-divider Channel Pairs
            el-row(v-if="pairs.length === 0" justify="center" type="flex")
              p
              | It looks like you don't have any channel pairs.
              | You can add a new pair with the button below.
            el-row(v-else type="block" v-loading="processing")
              el-card(v-for="pair in pairs" :key="pair.id")
                span.highlight {{pair.name}}
                span.float.right
                  el-divider(direction="vertical")
                  NuxtLink(:to="`/pair?id=${pair.id}`")
                    el-tooltip.item(effect="dark" placement="top" content="Edit")
                      el-button(type="primary" rounded plain size="mini") #[i.bx.bx-edit]
                  el-tooltip.item(effect="dark" placement="top" content="Duplicate")
                    el-button(rounded plain size="mini" :loading="processing" :disabled="processing" @click="doDuplicate(pair)") #[i.bx.bx-copy]
                  NuxtLink(:to="`/tracks?id=${pair.id}`")
                    el-tooltip.item(effect="dark" placement="top" content="History")
                      el-button(rounded plain size="mini") #[i.bx.bx-time]
                  NuxtLink(:to="`/logs?id=${pair.id}`")
                    el-tooltip.item(effect="dark" placement="top" content="Logs")
                      el-button(rounded plain size="mini") #[i.bx.bx-book]
                  el-tooltip.item(effect="dark" placement="top" content="Delete")
                    el-button(type="danger" rounded plain size="mini" :loading="processing" :disabled="processing" @click="doDelete(pair)") #[i.bx.bx-trash]
              el-row(justify="center" type="flex")
                p You have #[span.highlight {{pairs.length}}] pair{{pairs.length > 1 ? 's' : ''}} of Discord channel webhooks.
              el-row(justify="center" type="flex")
                p You can press the edit button on the left to see detailed controls for the channel pair.
            el-row(justify="center" type="flex")
              el-button(type="primary" plain :loading="processing" :disabled="processing" @click="createPair()") #[i.bx.bx-plus(v-if="!processing")] Add
          div(v-else-if="loading")
            el-row(justify="center" align="middle" type="flex")
              p #[i.bx.bx-spa] Loading...
            el-row(justify="center" type="flex")
              p(v-loading="loading" element-loading-background="rgba(255, 255, 255, 0.75)") {{quote}}
            el-row(justify="center" type="flex")
              p Please wait while we fetch all your channel pairs...
          div(v-else)
            el-row(justify="center" align="middle" type="flex")
              p #[i.bx.bx-ghost] You aren't supposed to be here, it seems.
            el-divider Please...
            el-row(justify="center" type="flex")
              NuxtLink(to="/") #[el-button(type="primary") #[i.bx.bx-home] Go Home]
    el-dialog(v-if="toDelete" :title="`Are you sure you want to delete ${toDelete.name}?`" :visible.sync="showDelete")
      slot($footer)
        el-button(@click="deletePair" type="danger") #[i.bx.bx-trash] Delete
        el-button(@click="toDelete = null") #[i.bx.bx-x] Cancel
</template>

<script lang="ts">
import Vue from 'vue'

import Easter from '@/middleware/easter'

const easter = new Easter()

function getQuote () {
  const quoter = easter.pick()
  let text = quoter.quotes[Math.floor(Math.random() * quoter.quotes.length)]
  text = `${quoter.icon} ${text}`
  return text
}

async function getUser (token: string) {
  const api = '/api/v1/user'
  return await fetch(api, {
    method: 'GET',
    headers: {
      Authorization: token
    }
  })
}

async function getPairs (token: string) {
  const api = '/api/v1/pair'
  return await fetch(api, {
    method: 'GET',
    headers: {
      Authorization: token
    }
  })
}

async function createPair (ctx: any) {
  const api = '/api/v1/pair'
  const resp = await fetch(api, {
    method: 'POST',
    headers: {
      Authorization: ctx.token
    }
  })
  await loadPairs(ctx)
  return resp
}

function frontToBackPair (original: any) {
  const pair = JSON.parse(JSON.stringify(original))
  const sfwPieces = pair.sfw.full.split('/')
  const sfwToken = sfwPieces[sfwPieces.length - 1]
  const sfwId = sfwPieces[sfwPieces.length - 2]
  pair.sfw.id = sfwId
  pair.sfw.token = sfwToken
  const nsfwPieces = pair.nsfw.full.split('/')
  const nsfwToken = nsfwPieces[nsfwPieces.length - 1]
  const nsfwId = nsfwPieces[nsfwPieces.length - 2]
  pair.nsfw.id = nsfwId
  pair.nsfw.token = nsfwToken
  if (!pair.sfw.full) {
    pair.sfw = null
  }
  if (!pair.nsfw.full) {
    pair.nsfw = null
  }
  return pair
}

function backToFrontPair (pair: any) {
  return {
    id: pair.id,
    sfw: pair.sfw ? pair.sfw : { id: 0, token: '', full: '' },
    nsfw: pair.nsfw ? pair.nsfw : { id: 0, token: '', full: '' },
    name: pair.name,
    settings: pair.settings
      ? pair.settings
      : {
          tags: {
            nsfw: [],
            exclude: [],
            require: [],
            ratings: {
              safe: false,
              questionable: false,
              explicit: false
            }
          },
          sources: {
            sites: {
              yandere: false,
              konachan: false,
              safebooru: false,
              reddit: false
            },
            subs: []
          },
          margins: {
            age: 0,
            score: 0,
            active: false
          },
          active: false
        }
  }
}

async function putPair (token: string, data: any) {
  const api = `/api/v1/pair/${data.id}`
  return await fetch(api, {
    method: 'PUT',
    headers: {
      Authorization: token,
      'Content-Type': 'application/json'
    },
    body: JSON.stringify(data)
  })
}

async function deletePair (ctx: any, id: number) {
  const api = `/api/v1/pair/${id}`
  const resp = await fetch(api, {
    method: 'DELETE',
    headers: {
      Authorization: ctx.token
    }
  })
  await loadPairs(ctx)
  return resp
}

async function loadPairs (ctx: any) {
  const pairs = await getPairs(ctx.token)
  ctx.pairs = await pairs.json()
}

export default Vue.extend({
  data () {
    return {
      pairs: [],
      user: null,
      token: window.localStorage.getItem('coco_token'),
      quote: getQuote(),
      loading: true,
      processing: false,
      toDelete: null as any,
      showDelete: false
    }
  },
  async mounted () {
    if (typeof (this.token) === 'string') {
      const user = await getUser(this.token)
      this.user = await user.json()
      await loadPairs(this)
      this.loading = false
    }
  },
  methods: {
    getAvatar (): string | null {
      const user = this.user as any
      const ext = user.avatar.indexOf('a_') === 0 ? 'gif' : 'png'
      return `https://cdn.discordapp.com/avatars/${user.id}/${user.avatar}.${ext}`
    },
    createPair () {
      const ctx = this
      ctx.processing = true
      createPair(this)
        .then((resp) => {
          if (resp.status !== 201) {
            ctx.$notify({ title: 'Failed to create a new pair.', message: `Received response code ${resp.status}.`, type: 'error' })
          } else {
            resp.json().then((data) => {
              ctx.$router.push({ path: `/pair?id=${data.id}` })
            })
          }
        })
        .finally(() => {
          ctx.processing = false
        })
    },
    doDelete (pair: any) {
      this.toDelete = pair
      this.showDelete = true
    },
    doDuplicate (pair: any) {
      const ctx = this
      ctx.processing = true
      createPair(this)
        .then((resp) => {
          if (resp.status !== 201) {
            ctx.$notify({ title: 'Failed to create a new pair.', message: `Received response code ${resp.status}.`, type: 'error' })
          } else {
            resp.json().then((data) => {
              const protoPair = JSON.parse(JSON.stringify(pair))
              protoPair.sfw = null
              protoPair.nsfw = null
              const newPair = backToFrontPair(protoPair)
              newPair.id = data.id
              newPair.name = `Copy of ${pair.name}`
              putPair(ctx.token as string, frontToBackPair(newPair)).then((resp) => {
                if (resp.status === 200) {
                  ctx.$notify({ title: 'Ok.', message: `Duplicated ${pair.name}.`, type: 'success' })
                  ctx.$router.push({ path: `/pair?id=${data.id}` })
                } else {
                  ctx.$notify({ title: 'Failed to save the pair.', message: `Received response code ${resp.status}.`, type: 'error' })
                }
              })
            })
          }
        })
        .finally(() => {
          ctx.processing = false
        })
    },
    deletePair () {
      const ctx = this
      ctx.processing = true
      deletePair(this, this.toDelete.id)
        .then((resp) => {
          if (resp.status !== 200) {
            ctx.$notify({ title: 'Failed to create a new pair.', message: `Received response code ${resp.status}.`, type: 'error' })
          }
        })
        .finally(() => {
          ctx.processing = false
        })
      ctx.toDelete = null
      ctx.showDelete = false
    },
    logOut () {
      window.localStorage.removeItem('coco_token')
      window.location.href = '/'
    }
  }
})
</script>

<style lang="scss" scoped>
.float.right {
  float: right;
}
</style>
